#! /usr/bin/env python
# This code comes from
# http://code.activestate.com/recipes/491264-mini-fake-dns-server/
# with some modifications
import socket
import dns.resolver

IP = ""
if IP == "":
    IP = socket.gethostbyname(socket.gethostname())
print "IP: ", IP

class DNSQuery:
  def __init__(self, data):
    self.data=data
    self.domain=''
    tipo = (ord(data[2]) >> 3) & 15
    if tipo == 0:
      ini=12
      lon=ord(data[ini])
      while lon != 0:
        self.domain+=data[ini+1:ini+lon+1]+'.'
        ini+=lon+1
        lon=ord(data[ini])

  def respuesta(self, ip):
    packet=''
    if self.domain:
      packet+=self.data[:2] + "\x81\x80"
      packet+=self.data[4:6] + self.data[4:6] + '\x00\x00\x00\x00'
      packet+=self.data[12:]
      packet+='\xc0\x0c'
      packet+='\x00\x01\x00\x01\x00\x00\x00\x3c\x00\x04'
      packet+=str.join('',map(lambda x: chr(int(x)), ip.split('.')))
    return packet

if __name__ == '__main__':
  udps = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
  udps.bind(('',53))
  resolver = dns.resolver.Resolver()
  resolver.nameservers = ['8.8.8.8']

  while 1:
    try:
      data, addr = udps.recvfrom(1024)
      p = DNSQuery(data)
      if p.domain == 'opds.gk.sdo.com.':
        ip = IP
      else:
        try:
          ip = str(resolver.query(p.domain)[0])
        except:
          ip = "127.0.0.1"
      udps.sendto(p.respuesta(ip), addr)
      print p.domain + "=>" + ip
    except KeyboardInterrupt:
      udps.close()
      break
    except:
      udps.close()
      udps = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
      udps.bind(('',53))  